# shellcheck shell=bash
# Print a symbol representing the host operating system.

if patched_font_in_use; then
	TMUX_POWERLINE_SEG_OS_SYMBOL_ALPINE=""
	TMUX_POWERLINE_SEG_OS_SYMBOL_ARCH="󰣇"
	TMUX_POWERLINE_SEG_OS_SYMBOL_DEBIAN=""
	TMUX_POWERLINE_SEG_OS_SYMBOL_LINUX=""
	TMUX_POWERLINE_SEG_OS_SYMBOL_MACOS=""
	TMUX_POWERLINE_SEG_OS_SYMBOL_RASPBIAN=""
	TMUX_POWERLINE_SEG_OS_SYMBOL_REDHAT=""
	TMUX_POWERLINE_SEG_OS_SYMBOL_ROCKY=""
	TMUX_POWERLINE_SEG_OS_SYMBOL_SUSE=""
	TMUX_POWERLINE_SEG_OS_SYMBOL_UBUNTU=""
else #utf-8 chars
	TMUX_POWERLINE_SEG_OS_SYMBOL_ALPINE="^"
	TMUX_POWERLINE_SEG_OS_SYMBOL_ARCH="A"
	TMUX_POWERLINE_SEG_OS_SYMBOL_DEBIAN="@"
	TMUX_POWERLINE_SEG_OS_SYMBOL_LINUX="L"
	TMUX_POWERLINE_SEG_OS_SYMBOL_MACOS="M"
	TMUX_POWERLINE_SEG_OS_SYMBOL_RASPBIAN="π"
	TMUX_POWERLINE_SEG_OS_SYMBOL_REDHAT="R"
	TMUX_POWERLINE_SEG_OS_SYMBOL_ROCKY="◶"
	TMUX_POWERLINE_SEG_OS_SYMBOL_SUSE="S"
	TMUX_POWERLINE_SEG_OS_SYMBOL_UBUNTU="U"
fi

generate_segmentrc() {
	read -r -d '' rccontents <<EORC
#Operating System Symbols
export TMUX_POWERLINE_SEG_OS_SYMBOL_ALPINE="${TMUX_POWERLINE_SEG_OS_SYMBOL_ALPINE}"
export TMUX_POWERLINE_SEG_OS_SYMBOL_ARCH="${TMUX_POWERLINE_SEG_OS_SYMBOL_ARCH}"
export TMUX_POWERLINE_SEG_OS_SYMBOL_DEBIAN="${TMUX_POWERLINE_SEG_OS_SYMBOL_DEBIAN}"
export TMUX_POWERLINE_SEG_OS_SYMBOL_LINUX="${TMUX_POWERLINE_SEG_OS_SYMBOL_LINUX}"
export TMUX_POWERLINE_SEG_OS_SYMBOL_MACOS="${TMUX_POWERLINE_SEG_OS_SYMBOL_MACOS}"
export TMUX_POWERLINE_SEG_OS_SYMBOL_RASPBIAN="${TMUX_POWERLINE_SEG_OS_SYMBOL_RASPBIAN}"
export TMUX_POWERLINE_SEG_OS_SYMBOL_REDHAT="${TMUX_POWERLINE_SEG_OS_SYMBOL_REDHAT}"
export TMUX_POWERLINE_SEG_OS_SYMBOL_ROCKY="${TMUX_POWERLINE_SEG_OS_SYMBOL_ROCKY}"
export TMUX_POWERLINE_SEG_OS_SYMBOL_SUSE="${TMUX_POWERLINE_SEG_OS_SYMBOL_SUSE}"
export TMUX_POWERLINE_SEG_OS_SYMBOL_UBUNTU="${TMUX_POWERLINE_SEG_OS_SYMBOL_UBUNTU}"
EORC
	echo "$rccontents"
}

run_segment() {
	if [[ "$(hostname)" = ${GITLAB_WORKSTATION} ]]; then
		echo "󰮠"; return 0
	fi
	if [[ "$(uname)" =~ Darwin ]]; then
		echo ${TMUX_POWERLINE_SEG_OS_SYMBOL_MACOS}
	elif test -f /etc/rpi-issue ; then
		echo ${TMUX_POWERLINE_SEG_OS_SYMBOL_RASPBIAN}
	else
		RELEASE=$(awk -F= '/^ID=/ {print $2}' /etc/os-release 2> /dev/null) \
			|| RELEASE=unknown
		case ${RELEASE} in
			*alpine*)	echo ${TMUX_POWERLINE_SEG_OS_SYMBOL_ALPINE}	;;
			*debian*)	echo ${TMUX_POWERLINE_SEG_OS_SYMBOL_DEBIAN}	;;
			*rh*)	echo ${TMUX_POWERLINE_SEG_OS_SYMBOL_REDHAT}	;;
			*arch*)	echo ${TMUX_POWERLINE_SEG_OS_SYMBOL_ARCH}	;;
			*buntu*)	echo ${TMUX_POWERLINE_SEG_OS_SYMBOL_UBUNTU}	;;
			*rocky*)	echo ${TMUX_POWERLINE_SEG_OS_SYMBOL_ROCKY}	;;
			*suse*)	echo ${TMUX_POWERLINE_SEG_OS_SYMBOL_SUSE}	;;
			*)	echo ${TMUX_POWERLINE_SEG_OS_SYMBOL_LINUX}
		esac
	fi
}
